#include <Wire.h>
#include <Adafruit_BMP280.h>
#include <iarduino_RTC.h>
#include <LiquidCrystal_I2C.h>

iarduino_RTC time(RTC_DS3231);
LiquidCrystal_I2C lcd(0x27, 20, 4); 
Adafruit_BMP280 bmp;


const float mid_p = 740.0;//Среднее давление для данной местности в мм рт.ст. Подставьте своё!!!

    int i;                    // Cчётчик циклов for
    int j;                    // -------//---------
    long p;                   // Текущее давление в Pa (1Pa=0.0075006376 мм рт.ст.)
    long sum_p6;              // Сумма результатов измерения давления за 6 сек.
    long mini_p6;             // Минимум давления за 6 сек.
    long maxi_p6;             // Максимум давления за 6 сек. 
    float  hg_p;              // Давление в мм рт.ст.
    float dif_pm;         // Разность давлений - текущего и среднего (mid_p) в мм рт.ст.
    float dif_p1;         // Разность давлений - текущего и того, что было 1 час назад  
    float dif_p3;         // Разность давлений - текущего и того, что было 3 часа назад 
    float dif_p10;       // Разность давлений - текущего и того, что было 10 часов назад  
    boolean flag;        // Флаг, разрешающий выводить dif_p1, dif_p3, dif_p10 c двумя доп. пробелами
    long sum_p[60];    // Массив для хранения 60-ти сумм p.Каждая сумма - 10000          измерений за 10 минут    
    
    float t;                  // Текущая темература в градусах C
    float sum_t6;             // Сумма результатов измерения температуры за 6 сек
    float mini_t6;            // Минимум температуры за 6 сек
    float maxi_t6;            // Максимум температуры за 6 сек 
  
void setup() {
  delay(300);              // Ждем готовности модуля отвечать на запросы
  time.begin();
  lcd.init();                                         
  lcd.backlight(); 
      
  for(i=0; i<60; i++)           // Обнуление массива sum_p[i] 
  sum_p[i]=0;      
    
  if (!bmp.begin(0x76)) {       // Датчик давления неисправен
  while (1) {}                  // Зациклить
  }
  }
  
void loop() {

  Serial.println(time.gettime("d-m-Y, H:i:s, D")); // Выводим время в монитор порта.
  lcd.setCursor(0, 1);                 // Установка курсора экрана.
  lcd.print(time.gettime("   H:i:s "));    // Выводим время на экран.      
  lcd.setCursor(0, 0);
  lcd.print(time.gettime(" d-m-Y D"));               
  delay(1000);

  
  sum_p[0] = 0;  // В цикле for по j в sum_p[0] будем копить сумму 10000 измерений
  for (j=0;j<100;j++) {    // Внешний цикл - проводим 10000 измерений за 600 сек 

    sum_p6=0;                    // Готовим данные для внутреннего цикла
    mini_p6=110000;              // Заведомо больше возможного 
    maxi_p6= 80000;              // Заведомо меньше возможного
    sum_t6=0;           
    mini_t6=100.0;               // Заведомо больше возможного  
    maxi_t6=0.0;                // Заведомо меньше возможного 
    
        for(i=0;i<102;i++) {     // Внутренний цикл - проводим 102 измерения за 6 сек 
      
        p=bmp.readPressure();
                        
        if (p<mini_p6)         // Находим max и min результаты, чтобы потом их отбросить
         mini_p6=p;
        if (p>maxi_p6)
         maxi_p6=p;  
        sum_p6=sum_p6 + p;

        t=bmp.readTemperature();
        if (t<mini_t6)
          mini_t6=t;
        if (t>maxi_t6)
          maxi_t6=t;  
        sum_t6=sum_t6 + t;
           
        delay(18);         // Подгоняем длительность внутреннего цикла к 6-ти секундам 
      }                    // закончили внутренний 6-ти секундный цикл по i

    sum_p[0]=sum_p[0]+sum_p6-maxi_p6-mini_p6;
    hg_p=0.7500638E-4 * (sum_p6-maxi_p6-mini_p6);          
    dif_pm=(hg_p - mid_p);
    digitalWrite (8,LOW);        // Зажигаем светодиод - выводим новый результат
    
    // Выводим на индикатор верхнюю строку - текущее давление, отклонение_ 
     // давления от среднего значения и температуру. 
         
    lcd.setCursor (-4,2);
    lcd.print ("P=");                   
    lcd.print (hg_p,1);
    lcd.print ("");
    //if (dif_pm >=0)                // Знак "+" или "-" ставим сами
    //lcd.print ("+");               //откл  
    //else                           //откл  
    //lcd.print ("-");
    //lcd.print (abs (dif_pm),1);
    lcd.print ("  T=");
    if (abs(dif_pm)>=9.95){   // Если dif_pm длинное (5 знакомест), то t выводим без десятых долей 
    lcd.print (0.01*(sum_t6-maxi_t6-mini_t6),0);
      lcd.print ("C*");              // Очистка 16-го знакоместа
    }
      else                            // Иначе - выводим t с десятыми
      lcd.print(0.01*(sum_t6-maxi_t6-mini_t6),1);  
    
      delay(83);                      // Подгоняем длительность внешнего цикла к 10 минутам  
      digitalWrite (8,HIGH);          // Гасим светодиод   
                  
  }                         // закончили внешний 10-ти минутный цикл по j

    dif_p1 = (sum_p[0] - sum_p[6]) * 0.7500638E-6;
    dif_p3 = (sum_p[0] - sum_p[18]) * 0.7500638E-6;
    dif_p10 = (sum_p[0] - sum_p[59]) * 0.7500638E-6;
    
    flag=false;          // По умолчанию два доп. пробела во 2-ю строку вставлять нельзя
    if (abs(dif_p1)<9.95 and abs(dif_p3)<9.95 and abs(dif_p10)<9.95)
    flag=true;         // Если dif_p занимают по 4 знакоместа, то пробелы вставить можно
    if (sum_p[59]==0)  // Если данных для dif_p10 ещё нет, то пробелы вставить можно      
    flag=true;
       
  // Выводим dif_p1, dif_p3 и dif_p10  во 2-ю (нижнюю)строку индикатора 

    lcd.setCursor (-4,3);
    lcd.print ("                "); // Очищаем 2-ю строку
    lcd.setCursor (-4,3);
    
  // Час назад...
     
      if (sum_p[6]>0) {           // Если сбор данных начался больше, чем час назад
      if (dif_p1 >=0)               // Знак "+" или "-" ставим сами
      lcd.print ("+");
      else 
      lcd.print ("-");     
      lcd.print (abs (dif_p1),1);
      lcd.print (" "); 
    }
      else                            // Данных пока нет... 
      lcd.print ("--.- ");

      if (flag==true)
      lcd.print (" ");

      // 3 Часа назад...
         
    if (sum_p[18]>0) {           // Если сбор данных начался больше, чем 3 часа назад
      if (dif_p3 >=0)            // Знак "+" или "-" ставим сами
         lcd.print ("+");
      else 
      lcd.print ("-");     
      lcd.print (abs (dif_p3),1);
      lcd.print (" "); 
    }
      else                            // Данных пока нет...  
      lcd.print ("--.- ");

      if (flag==true)
      lcd.print (" ");
      
      // 10 Часов назад... 
        
      if (sum_p[59]>0) {      // Если сбор данных начался больше, чем 10 часов назад
      if (dif_p10>=0)               // Знак "+" или "-" ставим сами
      lcd.print ("+");
      else 
      lcd.print ("-");     
      lcd.print (abs (dif_p10),1);
    }
      else                            // Данных пока нет... 
      lcd.print ("--.-");
  
    // Сдвигаем содержимое массива sum_p[] на одну позицию вправо 
  
    for(i=59;i>0;i--)
    sum_p[i] = sum_p[i-1];
    
   } 

  // Конец скетча
